<template>
  <div class="data-wrapper"
    @keyup.page-up="prevPage"
    @keyup.page-down="nextPage">
    <div class="d-flex">
      <b-button-toolbar aria-label="Toolbar with button groups and dropdown menu">
        <b-button :to="createRoute()"  :disabled="hasRowsSelected" variant="primary" class="mr-2">Create New</b-button>

        <b-button-group class="mx-2">
          <b-button v-if="hasRowsSelected" variant="danger">Delete Selected</b-button>
        </b-button-group>
      </b-button-toolbar>

      <div class="ml-auto">
        <b-form-input
          :disabled="hasRowsSelected"
          ref="searchInput"
          type="search"
          placeholder="Search"
          @input="onRowFiltered"
          />
      </div>
    </div>

    <b-card no-body class="my-3">
      <b-table show-empty no-local-sorting hover
        ref="table"
        :fields="fields"
        :items="items"
        :primary-key="primary"
        :responsive="true"
        :busy="busy"
        :per-page="perPage"
        :current-page="currentPage"
        :sort-by="sortBy"
        :sort-desc="sortDesc"
        @row-clicked="onRowClicked"
        @row-dblclicked="onRowDoubleClicked"
        @sort-changed="onSortChanged">
        <template :slot="`HEAD_${primary}`">
          <b-form-checkbox
            name="all-selected"
            :disabled="busy"
            :checked="allRowsSelected"
            :indeterminate="someRowsSelected"
            @change.native="$emit('all-rows-selected', !allRowsSelected, $event)"/>
        </template>

        <template :slot="primary" slot-scope="data">
          <b-form-checkbox
            name="selected[]"
            :disabled="busy"
            :checked="isSelected(data.item)"
            @change="$emit('row-selected', data.item, $event)"
            @click.native.stop/>
        </template>

        <template v-if="thumb" :slot="thumb" slot-scope="data">
          <b-img :src="data.value" :alt="data.key" rounded style="width: 60px; height: auto;"/>
        </template>

        <template slot="actions" slot-scope="cell">
          <div class="action-btns">
            <b-link class="action-btn"
              :disabled="isSelected(cell.item)"
              @click.stop="$emit('row-edit-clicked', cell.item, $event)">
              <icon name="edit-3" square="18"/>
            </b-link>

            <b-link class="action-btn text-danger"
              :disabled="isSelected(cell.item)"
              @click.stop="$emit('row-delete-clicked', cell.item, $event)">
              <icon name="trash" square="18"/>
            </b-link>
          </div>
        </template>
      </b-table>
    </b-card>

    <div class="d-flex">
      <b-form-select class="form-control"
        :disabled="disablePageOptions"
        :value="perPage"
        :options="pageOptions"
        @change="onPageOptionsChanged"/>

      <p class="summary" v-html="totalText"></p>

      <b-pagination class="my-0 ml-auto"
        v-model="page"
        :value="currentPage"
        :total-rows="totalRows"
        :per-page="perPage"
        :disabled="disablePagination"
        @input="onPaging" />
    </div>
  </div>
</template>

<script>
import debounce from 'lodash/debounce'

import { reducer } from '@/utilities'

export default {
  name: 'table-view',

  data () {
    return {
      page: this.currentPage
    }
  },

  props: {
    name: {
      type: String
    },

    primary: {
      type: String,
      default: 'id'
    },

    data: {
      type: Array,
      default () {
        return []
      }
    },

    columns: {
      type: [Array, Object],
      default () {
        return []
      }
    },

    busy: {
      type: Boolean,
      default: false
    },

    sort: {
      type: [Object, Array, String],
      default () {
        return this.primary
      }
    },

    currentPage: {
      type: Number,
      default: 1
    },

    perPage: {
      type: Number,
      default: 15
    },

    pageOptions: {
      type: Array,
      default () {
        return [0, 15, 50, 100]
      }
    },

    selectedRows: {
      type: Array,
      default () {
        return []
      }
    },

    total: {
      type: Number,
      default: 0
    }
  },

  computed: {
    items () {
      const items = this.data.map(item => {
        item.actions = null
        return item
      })
      console.log(items)

      return items
    },

    fields () {
      const columns = !Array.isArray(this.columns)
        ? Object.values(this.columns)
        : this.columns

      return reducer.column.call(this, columns)
    },

    sortBy () {
      if (typeof this.sort === 'string') {
        return this.sort || this.primary
      } else if (Array.isArray(this.sort)) {
        return this.sort[0] || this.primary
      } else {
        return Object.keys(this.sort)[0] || this.primary
      }
    },

    sortDesc () {
      if (typeof this.sort === 'string' || Array.isArray(this.sort)) {
        return true
      }

      return this.sort[this.sortBy] === 'desc'
    },

    thumb () {
      const field = this.fields.find(field => field.type === 'image')

      return field ? field.key : null
    },

    disablePagination () {
      if (this.busy) return true

      return this.totalRows <= this.perPage
    },

    disableSelectRows () {
      return this.busy || this.hasRowsSelected || this.totalRows === 0
    },

    disablePageOptions () {
      return this.busy || this.hasRowsSelected
    },

    totalText () {
      return this.totalRows > 0 ? `Total data ${this.totalRows}` : 'No data'
    },

    totalRows () {
      return this.total || this.items.length
    },

    allRowsSelected () {
      return this.selectedRows.length > 0 && this.selectedRows.length === this.items.length
    },

    someRowsSelected () {
      return this.selectedRows.length > 0 && this.items.length > this.selectedRows.length
    },

    hasRowsSelected () {
      return this.selectedRows.length > 0 && this.items.length >= this.selectedRows.length
    }
  },

  methods: {
    isSelected (item) {
      return this.selectedRows.includes(item[this.primary])
    },

    selectRow (item) {
      if (this.selectedRows.includes(item[this.primary])) {
        this.selected = this.selectedRows.filter(id => id !== item[this.primary])
      } else {
        this.selectedRows.push(item[this.primary])
      }
    },

    createRoute () {
      return {
        name: `${this.name}.create`
      }
    },

    editRoute (item) {
      return {
        name: `${this.name}.edit`,
        params: {
          [this.primary]: item[this.primary]
        }
      }
    },

    prevPage () {
      console.log('Prev')
    },

    nextPage () {
      console.log('Next')
    },

    onRowClicked (item, index, event) {
      this.$emit('row-clicked', item, index, event)
    },

    onRowDoubleClicked (item, index, event) {
      this.$emit('row-dblclicked', item, index, event)
    },

    onPaging (currentPage) {
      this.onContextChanged({
        currentPage,
        sortBy: this.sortBy
      })
    },

    onPageOptionsChanged (perPage) {
      this.onContextChanged({
        perPage,
        sortBy: this.sortBy
      })
    },

    onSortChanged (ctx) {
      this.onContextChanged(ctx)
    },

    onContextChanged ({ currentPage, perPage, sortBy, sortDesc }) {
      const context = {
        page: currentPage || this.currentPage,
        per_page: perPage || this.perPage,
        sort: {
          [sortBy]: sortDesc ? 'desc' : 'asc'
        }
      }
      // this.sortDesc = !sortDesc

      this.$emit('context-changed', context)
    },

    onRowFiltered: debounce(function (value) {
      this.$emit('row-filtered', value)
    }, 500)
  },

  mounted () {
    // this.$on()

    if (this.$refs.searchInput) {
      this.$refs.searchInput.$el.focus()
    }
  }
}
</script>

<style lang="scss">
.table {
  margin-bottom: 0;

  th, td {
    padding: .5rem;
    line-height: 1.4em;
  }

  .column-sortable {
    padding-right: 1.125em;
    position: relative;
    cursor: pointer;

    &:after {
      position: absolute;
      font-weight: bold;
      margin-left: 2px;
      top: 5px;
      display: block;
      right: .35em;
      font-size: inherit;
      line-height: inherit;
    }

    &[aria-sort="none"]:after {
      opacity: .6;
      content: "↕";
    }

    &[aria-sort="ascending"]:after {
      opacity: 1;
      content: "↓";
    }

    &[aria-sort="descending"]:after {
      opacity: 1;
      content: "↑";
    }
  }

  thead th {
    user-select: none;
    border-top: 0 !important;
  }

  tbody td {
    user-select: none;
    cursor: pointer;
  }
}

.custom-checkbox{
  margin-right: 0;
  min-height: 1rem;
}

.custom-select {
  width: auto;
  margin-right: 1em;
  display: flex;
  height: 32px;
}

.summary {
  line-height: 32px;
  margin-bottom: 0;
}

.action-btns {
  display: table;
  width: 100%;
}

.action-btn {
  display: table-cell;
  text-align: center;
  padding: 0 3px;

  &.disabled {
    color: $text-muted;
    cursor: not-allowed;
  }
}
</style>
